'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSelect = require('react-select');

var _reactSelect2 = _interopRequireDefault(_reactSelect);

var _reactTether = require('react-tether');

var _reactTether2 = _interopRequireDefault(_reactTether);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/** from https://github.com/JedWatson/react-select/issues/810#issuecomment-250274937 **/
var TetheredSelectWrap = function (_Select) {
  _inherits(TetheredSelectWrap, _Select);

  function TetheredSelectWrap(props) {
    _classCallCheck(this, TetheredSelectWrap);

    var _this = _possibleConstructorReturn(this, (TetheredSelectWrap.__proto__ || Object.getPrototypeOf(TetheredSelectWrap)).call(this, props));

    _this.renderOuter = _this._renderOuter;
    return _this;
  }

  _createClass(TetheredSelectWrap, [{
    key: '_renderOuter',
    value: function _renderOuter() {
      var menu = _get(TetheredSelectWrap.prototype.__proto__ || Object.getPrototypeOf(TetheredSelectWrap.prototype), 'renderOuter', this).apply(this, arguments);
      // Don't return an updated menu render if we don't have one
      if (!menu) {
        return;
      }
      /** this.wrapper comes from the ref of the main Select component (super.render()) **/
      var selectWidth = this.wrapper ? this.wrapper.offsetWidth : null;
      return _react2.default.createElement(
        _reactTether2.default,
        {
          renderElementTo: '.react-virtualized-mount-node',
          ref: 'tethered-component',
          attachment: 'top left',
          targetAttachment: 'top left',
          constraints: [{
            to: 'scrollParent',
            attachment: 'together',
            pin: ['top']
          }]
        },
        _react2.default.createElement('div', null),
        _react2.default.cloneElement(menu, { style: { position: 'static', width: selectWidth } })
      );
    }
  }]);

  return TetheredSelectWrap;
}(_reactSelect2.default);

exports.default = TetheredSelectWrap;